CREATE PROCEDURE [dbo].[PaginateTable]
(
	@PageSize INT = 30,
	@CurrentPageIndex INT = 0,
	@TableName VARCHAR(64),
	@KeyField VARCHAR(32) = 'Id',
	@RowFilter VARCHAR(3128) = NULL
)
AS
	DECLARE @ItemCount INT
	DECLARE @PageCount INT
	DECLARE @ItemCountSQL NVARCHAR(1024)
	DECLARE @WhereSQL VARCHAR(3128)
	IF (@RowFilter IS NOT NULL AND @RowFilter <> '')
		SET @WhereSQL = '  WHERE ' + @RowFilter
	ELSE
		SET @WhereSQL = ' '
	SET @ItemCountSQL = 'SELECT @ItemCount = COUNT(*) FROM ' + @TableName + @WhereSQL
	EXEC sp_ExecuteSql @ItemCountSQL,  N'@ItemCount INT OUT', @ItemCount OUT
	SET @PageCount = CEILING(@ItemCount*1.0/@PageSize)

	SELECT
		@ItemCount AS VirtualtemCount,
		CurrentPageIndex =
			CASE
				WHEN @CurrentPageIndex < @PageCount THEN @CurrentPageIndex
				ELSE NULL
			END,
		 @PageSize AS PageSize,  @PageCount AS PageCount

	DECLARE @ItemRollOut INT
	IF (@PageSize > 0)
		BEGIN
			SET @ItemRollOut = @ItemCount - @PageSize * @CurrentPageIndex
			IF (@ItemRollOut > 0)
				BEGIN
					SET ROWCOUNT @PageSize
					DECLARE @ItemSQL VARCHAR(6144)
					SET @ItemSQL = 'SELECT * FROM (SELECT TOP ' + CAST(@ItemRollOut AS VARCHAR(10)) + ' * FROM ' + @TableName + @WhereSQL + 'ORDER BY ' + @KeyField + ' DESC) AS TMP1 ORDER BY ' + @KeyField + '  ASC'
					EXEC (@ItemSQL)
				END
			ELSE
				SELECT NULL
		END
	ELSE
		SELECT NULL
GO
